/**
 * Copyright (c) 2000-2017 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * pSubscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.portal.dao.shard;

import com.liferay.portal.kernel.bean.PortalBeanLocatorUtil;

import org.hibernate.HibernateException;
import org.hibernate.SessionFactory;
import org.hibernate.classic.Session;
import org.hibernate.engine.SessionFactoryImplementor;

import org.springframework.orm.hibernate3.SessionFactoryUtils;
import org.springframework.orm.hibernate3.SpringSessionContext;

/**
 * @author Shuyang Zhou
 */
public class ShardSpringSessionContext extends SpringSessionContext {

	public ShardSpringSessionContext(SessionFactoryImplementor sessionFactory) {
		super(null);
	}

	@Override
	public Session currentSession() throws HibernateException {
		try {
			if (_sessionFactory == null) {
				_sessionFactory =
					(SessionFactory)PortalBeanLocatorUtil.locate(
						"liferayHibernateSessionFactory");
			}

			return (Session)SessionFactoryUtils.doGetSession(
				_sessionFactory, false);
		}
		catch (IllegalStateException ise) {
			throw new HibernateException(ise);
		}
	}

	private SessionFactory _sessionFactory;

}